//
//  TSVCL32.DLL      v1.0
//  Low level routines for TSVCL for Delphi 2.0x/3.0x
//  _________________________________________________
//
//  Sergei Dolgov (C) 1998
//
//

const
TSVCLDLL = 'tsvcl32.dll';   // The name of the library

//  ---------- Common graphics routines -------------

const
{Bitmap compare results}
bcError     = $FFFFFFFF;    // The bitmaps couldn't be compared
bcEqual     = $0;           // The bitmaps are equal
bcDifferent = $1;           // The bitmaps are different

{Hatch styles for DrawHatchedRect function}
hsBDiagonal     = 1;
hsFDiagonal     = 2;
hsHorizontal    = 4;
hsVertical      = 8;

type
{Hatch field definition record}
THatchDef = record
  Step: Integer;         {Hatch size}
  Style: Integer;        {Hatch flags}
end;

{Compare two bitmas}
function CompareBitmaps(Handle1,Handle2: HBITMAP): Longint; stdcall;

{Compare and returns the mask of differences}
function BitwiseCompareBitmaps(HRes,HArg1,HArg2: HBITMAP): Longint; stdcall;

{Shows animated rectangles on full screen form one rect to another}
function DisplayAnimatedRects(const StartR,EndR: TRect): Boolean; stdcall;

{Draw hatched rectangle on the canvas}
function DrawHatchedRect(Device: HDC; Rect: TRect; Def: THatchDef): Boolean; stdcall;



//  -------------- UMD manager -------------------

{Adds new "message dispatching path" (MDP)}
function UMD_AddMessagePath(Parent,Dest: HWND; Msg: Word): Boolean; stdcall;

{Removes the MDP}
function UMD_RemoveMessagePath(Parent,Dest: HWND; Msg: Word): Boolean; stdcall;

{Removes all MDPs}
function UMD_RemoveAllPaths: Boolean; stdcall;



// ------------- Multimedia extentions ------------

type
{ID of the source of the sound for playing}
TSoundSourceID = (ssAlias,            {Alias in the system registry}
                  ssAlias_ID,         {ID in the registry}
                  ssFilename,         {WAV file}
                  ssResource);        {The module resource}

{Structure for discribing the source and the playing mode}
TSoundSource=record
  Src: TSoundSourceID;        // The source of the sound
  Sync: Boolean;              // Synchro mode
  ID: AnsiString;             // Name (ID/Filename)
end;

{Plays the sound on MCI}
function MME_PlaySoundTrack(var STrack: TSoundSource; RM: HMODULE): Boolean; stdcall;





// --------- External declarations ------------

function CompareBitmaps; external TSVCLDLL name 'CompareBitmaps';
function BitwiseCompareBitmaps; external TSVCLDLL name 'BitwiseCompareBitmaps';
function DisplayAnimatedRects; external TSVCLDLL name 'DisplayAnimatedRects';
function DrawHatchedRect; external TSVCLDLL name 'DrawHatchedRect';
function UMD_AddMessagePath; external TSVCLDLL name 'UMD_AddMessagePath';
function UMD_RemoveMessagePath; external TSVCLDLL name 'UMD_RemoveMessagePath';
function UMD_RemoveAllPaths; external TSVCLDLL name 'UMD_RemoveAllPaths';
function MME_PlaySoundTrack; external TSVCLDLL name 'MME_PlaySoundTrack';




