(*
  _________________________________________________________________________
 |                                                                         |
 | Trivles Software Visual Components Library (Impact!)                    |
 |_________________________________________________________________________|
 |                                                                         |
 ||==||==| //==\                              Sergei Dolgov(c) 1998        |
 |   ||    \\__                               Trifles Software             |
 |   ||       \\                              http://ns.onego.ru/trifles/  |
 |   ||    \==//                              e-mail: sdolgov@onego.ru     |
 |_________________________________________________________________________|
  _________________________________________________________________________
 | Instalation tips                                                        |
 | - copy the file TSVCL32.DLL into the C:\WINDOWS\SYSTEM dirrectory       |
 | - install TSVCL.PAS as usual                                            |
 |_________________________________________________________________________|


  UNIT EXCEPTIONS

  EMMXError          General error inside the UNIT

  EWebBtnRR          Unrealized system resource
  EWebBtnURE         Unrecognized error
  EWebBtnOSR         Out of system resources
  EWebBtnNoParent    Can't determinate the parent form for the control

  EDistortionOSR     Out of system resources
  ____________________________________________________________________________________________

  CLASSES AND COMPONENTS

  1. Subclass of TForm with animated hide and show actions.

     TAniForm
     ========
     Properties:

     Background: TBitmap           - Background image (tiling). To discard the
                                     background assing nil to the property

     Methods:

     1.1. ShowFrom(TControl)       - 'Open' the form from the control
                                     using animated rectangles
     1.2. ShowModalFrom(TControl)  - 'Open' the form as modal from
                                     the control specified
     1.3. SelectHome(TControl)     - Specifying the control as source
                                     of animated rectangles for Show
                                     and Close etc methods
     1.4. DeselectHome             - Animation deactivating.
     1.5. HGradient(TColor,TColor) - Horizontal gradient from one color to another
     1.6. VGradient(TColor,TColor) - Vertical gradient...XGradient(clNone,clNone)
                                     discards previosly defined gradient background

  ____________________________________________________________________________________________

  2. Webbutton control, displays 'transparant GIF' which changes
     its image when mouse goes over client aria and launches OnClick
     event when user clicks on it

     TWebBtn
     =======
     Events:

     OnClick: TNotifyEvent         - Occures when user clicks on the button
     OnActivate: TNotifyEvent      - ... when button is about to be activated
     OnDeactivate: TNotifyEvent    - ... when button is about to be deactivated
     OnPrepare: TNotifyEvent       - ... when button changes its state from wbNormal to wbStandBy
     OnRestore: TNotifyEvent       - ... when button changes its state from wbStandBy to wbActive
     OnPlay: TNotifyEvent          - ... when button show next frame while playing (only wbGlyph)

     Properties:

     2.4. Width,Height: Integer    - Size of the button
     2.5. Style: TWBStyle          - Behavour:
                                   wbGlyph     - Manual control by Activate, Deactivate, StandBy,
                                               SetFrame, Play and Stop methods
                                   wbButton    - Activates when user clicks on the button,
                                               deactivates when user realizes the left
                                               mouse button
                                   wbWebButton - Go to StandByPos when mouse pointer moves over
                                               the button, deactivates when cursor leaves
                                               button's region, activates on click
                                   wbTrigger   - Activates/deactivates on one click
     2.6. State: TWBState          - Current state
                                   wbUndefined  - The button is not defined yet
                                   wbNormal     - Completely deactivated
                                   wbActive     - Completely activated
                                   wbActivating - is activating (for animated buttons)
                                   wbDeactivating - is deactivating (for animated buttons)
                                   wbPreparing  - is running from wbNormal to wbStandBy
                                   wbRestoring  - is running from wbActive to wbStandBy
                                   wbPlaying    - is playing pseudo video (wbGlyph)
      2.7. Glyph: TBitmap          - Frameset for animation (the first frame is for the normal
                                   state, the last is for the active state
      2.8. Frames: Integer         - Number of frames in the frameset
      2.9. Period: Integer         - Time delay in milliseconds between changing frames
                                   in animation
      2.10. Transparent: BOOL      - Controls transparency of the button
      2.11. ShowHint: BOOL         - Show hints
      2.12. StandByPos: Integer    - StandBy position (index of the "stand-by" frame in the frameset)
      2.13. Inverted: Boolean      - Inverted order of frames in the frameset (not recomended)
      2.14. PaletteMode: TPaletteMode - Displing mode
                                        none             - use halftone palette
                                        pmBestMapping    - best mapping
                                        pmDDB            - use device dependent bitmap for the frameset
                                        pmUsePalette     - use palette with the frameset
      2.15. MaximizeSpeed          - if True then animation accours with max speed and
                                     control intersection is not checked.
      2.16. MouseOver: Boolean     - (read only) True if move is over the control

     Public methods

     2.11. IsDefined      - Returns true if button is completely defined an ready to go
     2.12. Activate       - Forces the button to be activated as soon as possible
     2.13. Deactivate     - Forces the button to be deactivated as soon as possible
     2.14. StandBy        - Runs the button to the StandBy position (only for wbWebButton)
     2.15. Play           - Starts playing for wbGlyph
     2.16. Stop           - Stops playing for wbGlyph
     2.17. GetFrame: Integer - Returns index of the frame is being displayed
     2.18. SetFrame(Index: Integer) - Dispays the frame by its index

     Protected methods

     2.14. DoActivate; dynamic;        -  Protected procedure for OnActivate event
     2.16. DoDeactivate; dynamic;      .
     2.17. DoPrepare; dynamic;         .
     2.18. DoRestore; dynamic;         .
     2.19. DoPlay; dynamic;

     The button accepts the following messages has been passed through the parent form:

     WM_DEACTIVATEWB      - Forces all web buttons (wbWebButton style) within the form
                            to be deactivated. Message has no params and returns nothing
     WM_UPDATEBGROUND     - Notifies the button that area under the button had been changed
                            and sends the pointer to TPaintRect structure in lParam.
                            If Handle of the TParamRect is 0 or lparam = 0 then button
                            has to update its background using current screen contents
  ____________________________________________________________________________________________

  3.  TWebBtn control with easy sound support.

      TWebBtnEx
      =========

      additionaly has:

      property SoundTracks

      SoundTracks.OnActivate      - sound on activating (going to the last frame)
      SoundTracks.OnDeactivate    - ... deactivating (going to the first frame)
      SoundTracks.OnPrepare       - ... preparing (going from the first frame to the stand-by frame)
      SoundTracks.OnRestore       - ... restoring (going from the last frame to the stand-by frame)
      SoundTracks.OnPlay          - ... playing video (each time frames are changed)

      Any of them has the following proprties:

      Src = ssAlias          - play registered sound by its name stored in ID
            ssAlias_ID       - play registered sound by its ID
            ssFilename       - play a WAV file, in this case ID contains the file name
            ssResource       - play the sound stored in module resource

      Sync = False           - Returns immidiatly after start playing sound
             True            - Hang on until sound is over

      ID                     - contains file name or resource name or ID
  ____________________________________________________________________________________________
  
*)


unit TSVCL;

interface

uses Windows,
  Forms,
  Controls,
  Classes,
  Graphics,
  SysUtils,
  CommCtrl,
  Messages;

{$INCLUDE tsvcl.h}  // Header for the TSVCL32.DLL library.

const

{Text messages for user}
SMMXError       = 'General error. CODE=01';
SWebBtnRR       = 'Fatal Error (unrealized resource). CODE=01.01.01';
SWebBtnURE      = 'Enternal error. CODE=01.01.02';
SWebBtnOSR      = 'Runtime error: out of system resources. CODE=01.01.03';
SWebBtnNoParent = 'Fatal Error (no parent). CODE=01.01.04';

{Timer IDs}
tmrCursorCheck  = 1;
tmrAnimation    = 2;

{Additional Windows messages}
WM_UPDATEBGROUND = WM_USER + $DD01;  // Forces the button to update its background,
                                     // lParam - pointer to TPaintRect structure with
                                     // absolute screen coordinates of the area had been
                                     // updated and handle of DC with color data.
                                     // If DC=0 or lParam = O then the button has to upadte
                                     // its background using current screen contents
WM_DEACTIVATEWB  = WM_USER + $DD02;  // Forces all webbuttons become inactive
                                     // (no params)


type

{A WebBtn object runtime states}
TWBState = (wbUndefined,     {The button is not defined yet}
            wbNormal,        {Normal state (the first frame)}
            wbActive,        {Activated state (the last frame)}
            wbStandBy,       {"Stand-by" state for wbWebButton control}
            {---------- transient states --------------}
            wbActivating,    {      -------------------------> [wbActive]  }
            wbDeactivating,  {  [wbNormal] <------------------------       }
            wbPreparing,     {  [wbNormal] --> [wbStandBy]                 }
            wbRestoring,     {                 [wbStandBy] <-- [wbActive]  }
            wbPlaying);      {  [wbNormal] --> [wbStandBy] --> [wbActive] --> [wbNormal]...}


{WebBtn style}
TWBStyle = (wbGlyph,         {Manual control & animation}
            wbButton,        {Ordinary button}
            wbWebButton,     {Web link}
            wbTrigger);      {Trigger with two states}

TPaletteMode = set of (pmBestMapping,        {Best mapping}
                       pmDDB,                {Use device dependent bitmaps}
                       pmUsePalette);        {Use palette with the framelist}

{Types of gradient}
TGradient = (gtHor,          {Horizontal gradient}
             gtVer,          {Vertical gradient}
             gtDisabled);    {Gradient is disabled}

{TPaintRect - structure is passed by WM_UPDATEBGROUND message}
PPaintRect=^TPaintRect;
TPaintRect=record
  Rect: TRect;           {Screen coordinates of rectangle has been updated}
  Handle: HDC;           {Handle of DC with color data}
end;

{EXCEPTIONS}
EMMXError       = class(Exception);       {General Error}

{WebBtn}
EWebBtnRR       = class(EMMXError);
EWebBtnURE      = class(EMMXError);
EWebBtnOSR      = class(EMMXError);
EWebBtnCAD      = class(EMMXError);
EWebBtnNoParent = class(EMMXError);


TAniForm = class(TForm)
private
  FOriginObject: TControl;                   // The object form which animation occures
  FBGround: TBitmap;                         // Background of the form (using tiling)
  FGradientType: TGradient;                  // Gradient type
  FStartColor: TColor;                       // Color of starting point of the gradient
  FEndColor: TColor;                         // Color of ending point of the gradient
  FLastWidth: Integer;                       // Last Width
  FLastHeight: Integer;                      // Last Height
  procedure SetBGround(Bmp: TBitmap);
protected
  procedure DoHide; override;
  procedure DoShow; override;
  procedure Paint; override;
  procedure Resize; override;
public
  constructor Create(AOwner: TComponent); override;
  destructor Destroy; override;
  procedure ShowFrom(Caller: TControl);
  procedure ShowModalFrom(Caller: TControl);
  procedure SelectHome(Caller: TControl);
  procedure DeselectHome;
  procedure HGradient(SC,EC: TColor);
  procedure VGradient(SC,EC: TColor);
published
  property Background: TBitmap read FBGround write SetBGround;
end;

TWebBtn = class(TGraphicControl)
private
  FWindowHandle: HWND;                                                         // Handle of invisible window associated with button
  FParentHandle: HWND;                                                         // Handle of Parent Form
  FState: TWBState;                                                            // Current state
  FStyle: TWBStyle;                                                            // Webbutton style
  FGlyph: TBitmap;                                                             // The bitmap of the series
  FFrames: Integer;                                                            // Nomber of frames in the series
  FStandByPos: Integer;                                                        // Index of "stand-by" frame of wbWebButton control
  FCFrame: Integer;                                                            // Current frame (is being displayed)
  FPeriod: Integer;                                                            // Determinates speed of animation
  HGlyph: HIMAGELIST;                                                          // Series of frames
  FTransparent: Boolean;                                                       // True if the images have to be transparent and False otherwise
  FInverted: Boolean;                                                          // Specifies inverted frame order in the frameset
  FMouseOver: Boolean;                                                         // Readonly - True if mouse pointer is over the control. Attention: the property is defined only for wbWebButton control
  FPaletteMode: TPaletteMode;                                                  // Palette mode
  FOnActivate: TNotifyEvent;                                                   // Event on activate
  FOnDeactivate: TNotifyEvent;                                                 // Event on deactivate
  FOnPrepare: TNotifyEvent;                                                    // Event on prepare (going to wbStandby from wbNormal)
  FOnRestore: TNotifyEvent;                                                    // Event on restore (going to wbStandby from wbActive)
  FOnPlay: TNotifyEvent;                                                       // Event on frame change while playing
  FMask: TBitmap;                                                              // Mask for nonblink redraw operation
  FBuffer: TBitmap;                                                            // Buffer for containing of current screen image
  FBGround: TBitmap;                                                           // Buffer for current background under the button
  FTemp: TBitmap;                                                              // Temporary buffer for mask operations
  FBGLoaded: Boolean;                                                          // False when no background loaded for the conrol
  FMaxSpeed: Boolean;                                                          // True then maximize animation speed (no intersection with another controls allowed then)
  procedure UpdateBGround;                                                     // Update the background using current contents of the screen device
  procedure WindowProc(var Msg: TMessage);                                     // Window procedure for dispatching of messages
  procedure Resize(Dim: TPoint);                                               // Sets new size of button
  procedure SetStyle(Stl: TWBStyle);                                           // Sets new style of the button
  procedure SetGlyph(Bmp: TBitmap);                                            // Assign new glyph
  procedure SetFrames(j: Integer);                                             // Sets new number of frames
  procedure SetStandByPos(j: Integer);                                         // Sets index of the "stand-by" frame for wbWebButton control style
  procedure SetPeriod(Prd: Integer);                                           // Sets new animation period
  procedure SetTransparent(Flag: Boolean);                                     // Change raster method
  procedure SetInverted(Flag: Boolean);                                        // Sets new frame order in the frameset
  procedure SetPaletteMode(PM: TPaletteMode);                                  // Change palette mode
  function UpdateSeries(j: Integer): TPoint;                                   // Updates series with new bitmap and j-number of frames (0-autorecognize).Returns actual size of the button
  procedure ResetActivity;                                                     // Stops any activity of the button
  procedure ShowNextFrame;                                                     // Shows the next frame in series, for animation
  procedure CheckCursorPos;                                                    // Checks current cursor position
protected
  procedure Paint; override;                                                   // WM_PAINT
  procedure SetBounds(AL,AT,AW,AH: Integer); override;                         // Checks size/position changing
  procedure Loaded; override;                                                  // Initialize button after loading from the filler
  procedure Redraw; virtual;                                                   // Redraws the button without sending WM_PAINT message (blink-free)
  procedure MouseMove(Shift: TShiftState; X,Y: Integer); override;
  procedure MouseDown(Button: TMouseButton; Shift: TShiftState; X,Y: Integer); override;
  procedure MouseUp(Button: TMouseButton; Shift: TShiftState; X,Y: Integer); override;
  procedure DoActivate; dynamic;                                               // Protected procedure for OnActivate event
  procedure DoDeactivate; dynamic;                                             // ...
  procedure DoPrepare; dynamic;
  procedure DoRestore; dynamic;
  procedure DoPlay; dynamic;
public
  constructor Create(AOwner: TComponent); override;                            // Constructor
  destructor Destroy; override;                                                // Destructor
  function IsDefined: Boolean; dynamic;                                        // Checks whether the button has been copmletly defined
  procedure Activate;                                                          // Coerces the button to change its state to Active
  procedure Deactivate;                                                        // Coerces the button to change its state to Normal
  procedure StandBy;                                                           // Coerces the button to change its state to StandBy
  procedure Play;                                                              // Starts playing for wbGlyph
  procedure Stop;                                                              // Stops playing for wbGlyph
  function GetFrame: Integer;                                                  // Returns index of the frame is being displayed
  procedure SetFrame(Index: Integer);                                          // Dispays the frame by its index
published
  property ShowHint default False;
  property OnClick;
  property OnActivate: TNotifyEvent read FOnActivate write FOnActivate;
  property OnDeactivate: TNotifyEvent read FOnDeactivate write FOnDeactivate;
  property OnPrepare: TNotifyEvent read FOnPrepare write FOnPrepare;
  property OnRestore: TNotifyEvent read FOnRestore write FOnRestore;
  property OnPlay: TNotifyEvent read FOnPlay write FOnPlay;
  property Width default 16;
  property Height default 16;
  property Visible;
  property Enabled;
  property Style: TWBStyle read FStyle write SetStyle default wbButton;
  property State: TWBState read FState default wbUndefined;
  property Glyph: TBitmap read FGlyph write SetGlyph;
  property Frames: Integer read FFrames write SetFrames;
  property StandByPos: Integer read FStandByPos write SetStandByPos;
  property Period: Integer read FPeriod write SetPeriod default 50;
  property Transparent: Boolean read FTransparent write SetTransparent default True;
  property Inverted: Boolean read FInverted write SetInverted default False;
  property PaletteMode: TPaletteMode read FPaletteMode write SetPaletteMode default [];
  property MaximizeSpeed: Boolean read FMaxSpeed write FMaxSpeed default False;
  property MouseOver: Boolean read FMouseOver;
end;

TSoundTrack = class(TPersistent)
protected
  FModuleHandle: HMODULE;                                                      // Handle of module with sounde resource
public
  FSrc: TSoundSource;                                                          // The source of the sound
  constructor Create;
  function Play: Boolean;                                                      // Plays the sound
  procedure Stop;                                                              // Stops playing
published
  property Src: TSoundSourceID read FSrc.Src write FSrc.Src default ssFilename;
  property Sync: Boolean read FSrc.Sync write FSrc.Sync default False;
  property ID: AnsiString read FSrc.ID write FSrc.ID;
end;

TSoundTracks = class(TPersistent)
private
  FOnActivate: TSoundTrack;                                                    // Soundtrack for OnActivate event
  FOnDeactivate: TSoundTrack;                                                  // ...
  FOnPrepare: TSoundTrack;
  FOnRestore: TSoundTrack;
  FOnPlay: TSoundTrack;
public
  constructor Create;
  destructor Destroy; override;
published
  property OnActivate: TSoundTrack read FOnActivate write FOnActivate;
  property OnDeactivate: TSoundTrack read FOnDeactivate write FOnDeactivate;
  property OnPrepare: TSoundTrack read FOnPrepare write FOnPrepare;
  property OnRestore: TSoundTrack read FOnRestore write FOnRestore;
  property OnPlay: TSoundTrack read FOnPlay write FOnPlay;
end;

TWebBtnEx = class(TWebBtn)
private
  FSoundTracks: TSoundTracks;                                                  // Names of WAV files for playing on events
protected
  procedure DoActivate; override;                                              // Playing soundtracks on the events
  procedure DoDeactivate; override;                                            // ...
  procedure DoPrepare; override;
  procedure DoRestore; override;
  procedure DoPlay; override;
public
  constructor Create(AOwner: TComponent); override;
  destructor Destroy; override;
published
  property SoundTracks: TSoundTracks read FSoundTracks write FSoundTracks;
end;

const
{Styles for hatching}
UndefinedWebBtnVisualStyle:  THatchDef = (Step:5;Style:hsBDiagonal);

{Default size}
DefaultWBSize: TPoint = (X:16;Y:16);

{CONTROLS REGISTER FUNCTION}
procedure Register;

implementation

{ TWebBtn }

procedure TWebBtn.Paint;
begin
  if FMaxSpeed and FTransparent then UpdateBGround;
  Redraw;
end;

procedure TWebBtn.UpdateBGround;
begin
  if FBGLoaded then
  begin
    if Canvas.Handle<>0 then BitBlt(FTemp.Canvas.Handle,0,0,Width,Height,Canvas.Handle,0,0,SRCCOPY);
    if BitwiseCompareBitmaps(FMask.Handle,FTemp.Handle,FBuffer.Handle)=bcDifferent then
    begin
      BitBlt(FBGround.Canvas.Handle,0,0,Width,Height,FMask.Canvas.Handle,0,0,SRCPAINT);
      BitBlt(FTemp.Canvas.Handle,0,0,Width,Height,FMask.Canvas.Handle,0,0,MERGEPAINT);
      BitBlt(FBGround.Canvas.Handle,0,0,Width,Height,FTemp.Canvas.Handle,0,0,SRCAND);
    end;
  end
  else
  begin
    if Canvas.Handle<>0 then BitBlt(FBGround.Canvas.Handle,0,0,Width,Height,Canvas.Handle,0,0,SRCCOPY);
    FBGLoaded:=True;
  end;
end;

procedure TWebBtn.Redraw;
begin
  if FState=wbUndefined then DrawHatchedRect(Canvas.handle,ClientRect,UndefinedWebBtnVisualStyle)
  else if FTransparent then
  begin
    if not FMaxSpeed then UpdateBGround;
    BitBlt(FBuffer.Canvas.Handle,0,0,Width,Height,FBGround.Canvas.Handle,0,0,SRCCOPY);
    ImageList_Draw(HGlyph,FCFrame,FBuffer.Canvas.Handle,0,0,ILD_TRANSPARENT);
    if Canvas.Handle<>0 then BitBlt(Canvas.Handle,0,0,Width,Height,FBuffer.Canvas.Handle,0,0,SRCCOPY);
  end
  else if Canvas.Handle<>0 then ImageList_Draw(HGlyph,FCFrame,Canvas.Handle,0,0,ILD_NORMAL);
end;

procedure TWebBtn.SetBounds(AL,AT,AW,AH: Integer);
begin
  if State=wbUndefined then inherited SetBounds(AL,AT,AW,AH)
  else inherited SetBounds(AL,AT,Width,Height);
end;

procedure TWebBtn.Activate;
begin
  case FState of
    wbUndefined:
    if IsDefined then
    begin
      FState:=wbActive;
      FCFrame:=FFrames-1;
    end;
    wbNormal,wbStandBy:
    begin
      FState:=wbActivating;
      if SetTimer(FWindowHandle,tmrAnimation,FPeriod,nil)=0 then raise EWebBtnURE.Create(SWebBtnURE);
      DoActivate;
    end;
    wbDeactivating,wbPreparing,wbRestoring:
    begin
      FState:=wbActivating;
      DoActivate;
    end;
  end;
end;

procedure TWebBtn.Deactivate;
begin
  case FState of
    wbUndefined:
    if IsDefined then
    begin
      FState:=wbNormal;
      FCFrame:=0;
    end;
    wbActive,wbStandBy:
    begin
      FState:=wbDeactivating;
      if SetTimer(FWindowHandle,tmrAnimation,FPeriod,nil)=0 then raise EWebBtnURE.Create(SWebBtnURE);
      DoDeactivate;
    end;
    wbActivating,wbPreparing,wbRestoring:
    begin
      FState:=wbDeactivating;
      DoDeactivate;
    end;
  end;
end;

procedure TWebBtn.StandBy;
begin
  case FState of
    wbUndefined:
    if IsDefined then
    begin
      FState:=wbStandBy;
      FCFrame:=FStandByPos;
    end;
    wbActive:
    begin
      FState:=wbRestoring;
      if SetTimer(FWindowHandle,tmrAnimation,FPeriod,nil)=0 then raise EWebBtnURE.Create(SWebBtnURE);
      DoRestore;
    end;
    wbNormal:
    begin
      FState:=wbPreparing;
      if SetTimer(FWindowHandle,tmrAnimation,FPeriod,nil)=0 then raise EWebBtnURE.Create(SWebBtnURE);
      DoPrepare;
    end;
    wbActivating:
    begin
      if FCFrame<FStandByPos then
      begin
        FState:=wbPreparing;
        DoPrepare;
      end
      else
      begin
        FState:=wbRestoring;
        DoRestore;
      end;
    end;
    wbDeactivating:
    begin
      if FCFrame<=FStandByPos then
      begin
        FState:=wbPreparing;
        DoPrepare;
      end
      else
      begin
        FState:=wbRestoring;
        DoRestore;
      end;
    end;
  end;
end;

procedure TWebBtn.Play;
begin
  if FStyle=wbGlyph then case FState of
    wbNormal,wbActive,wbStandBy:
    begin
      FState:=wbPlaying;
      if SetTimer(FWindowHandle,tmrAnimation,FPeriod,nil)=0 then raise EWebBtnURE.Create(SWebBtnURE);
    end;
  end;
end;

procedure TWebBtn.Stop;
begin
  if FState=wbPlaying then FState:=wbNormal;
end;

function TWebBtn.GetFrame: Integer;
begin
  Result:=FCFrame;
end;

procedure TWebBtn.SetFrame(Index: Integer);
begin
  if Index<0 then FCFrame:=0 else
  if Index>=FFrames then FCFrame:=FFrames-1
  else FCFrame:=Index;
  Redraw;
end;

procedure TWebBtn.ShowNextFrame;
begin
  case FState of
    wbActivating:
    begin
      inc(FCFrame);
      if FCFrame>(FFrames-2) then
      begin
        KillTimer(FWindowHandle,tmrAnimation);
        FCFrame:=FFrames-1;
        FState:=wbActive;
      end;
      Redraw;
    end;
    wbDeactivating:
    begin
      dec(FCFrame);
      if FCFrame<1 then
      begin
        KillTimer(FWindowHandle,tmrAnimation);
        FCFrame:=0;
        FState:=wbNormal;
      end;
      Redraw;
    end;
    wbPreparing:
    begin
      inc(FCFrame);
      if FCFrame>=FStandByPos then
      begin
        KillTimer(FWindowHandle,tmrAnimation);
        FCFrame:=FStandByPos;
        FState:=wbStandBy;
      end;
      Redraw;
    end;
    wbRestoring:
    begin
      dec(FCFrame);
      if FCFrame<=FStandByPos then
      begin
        KillTimer(FWindowHandle,tmrAnimation);
        FCFrame:=FStandByPos;
        FState:=wbStandBy;
      end;
      Redraw;
    end;
    wbPlaying:
    begin
      inc(FCFrame);
      if FCFrame>=FFrames then FCFrame:=0;
      Redraw;
      DoPlay;
    end;
  else
    KillTimer(FWindowHandle,tmrAnimation);
  end;
end;

procedure TWebBtn.ResetActivity;
begin
  KillTimer(FWindowHandle,tmrAnimation);
  KillTimer(FWindowHandle,tmrCursorCheck);
end;

procedure TWebBtn.CheckCursorPos;
var
  CP: TPoint;
begin
  GetCursorPos(CP);
  if (ClientOrigin.X>CP.X) or
     (ClientOrigin.X+Width<CP.X) or
     (ClientOrigin.Y>CP.Y) or
     (ClientOrigin.Y+Height<CP.Y) then
  begin
    FMouseOver:=False;
    if (FState=wbStandBy) or (FState=wbDeactivating) or (FState=wbPreparing) then
    begin
      KillTimer(FWindowHandle,tmrCursorCheck);
      Deactivate;
    end;
  end;
end;

procedure TWebBtn.MouseMove(Shift: TShiftState; X, Y: Integer);
begin
  inherited;
  case FStyle of
    wbWebButton:
    begin
      FMouseOver:=True;
      if (FState=wbNormal) or (FState=wbDeactivating) then
      begin
        SendMessage(FParentHandle,WM_DEACTIVATEWB,0,0);    // Deactivate all web buttons within current form
        StandBy;
        if SetTimer(FWindowHandle,tmrCursorCheck,50,nil)=0 then raise EWebBtnURE.Create(SWebBtnURE);
      end;
    end;
  end;
end;

procedure TWebBtn.MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  inherited;
  if Button=mbLeft then case FStyle of
    wbButton: Activate;
    wbTrigger: if (FState=wbNormal) or (FState=wbDeactivating) then Activate else Deactivate;
    wbWebButton: if (FState=wbStandBy) or (FState=wbPreparing) or (FState=wbRestoring) then Activate;
  end;
end;

procedure TWebBtn.MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  inherited;
  if Button=mbLeft then case FStyle of
    wbButton: Deactivate;
    wbWebButton: if (FState=wbActive) or (FState=wbRestoring) or (FState=wbActivating) then StandBy;
  end;
end;

procedure TWebBtn.WindowProc(var Msg: TMessage);
var
  URct,CRct: TRect;
begin
  with Msg do
  case Msg of
    WM_TIMER:
    begin
      case wParam of
        tmrAnimation: ShowNextFrame;
        tmrCursorCheck: CheckCursorPos;
      end;
      Result:=0;
    end;
    WM_DEACTIVATEWB:
    begin
      if FStyle=wbWebButton then Deactivate;
      Result:=0;
    end;
    WM_UPDATEBGROUND:
    begin
      if FTransparent then
      begin
        if lParam<>0 then
        begin
          CRct.Left:=ClientOrigin.X;
          CRct.Right:=ClientOrigin.X+Width;
          CRct.Top:=ClientOrigin.Y;
          CRct.Bottom:=ClientOrigin.Y+Height;
          if IntersectRect(URct,PPaintRect(lParam)^.Rect,CRct) then
          begin
            if PPaintRect(lParam)^.Handle<>0 then
            begin
              URct.Left:=URct.Left-ClientOrigin.X;
              URct.Right:=URct.Right-ClientOrigin.X;
              URct.Top:=URct.Top-ClientOrigin.Y;
              URct.Bottom:=URct.Bottom-ClientOrigin.Y;
              BitBlt(FBGround.Canvas.Handle,
                     URct.Left,URct.Top,
                     URct.Right-URct.Left,URct.Bottom-URct.Top,
                     PPaintRect(lParam)^.Handle,
                     URct.Left+ClientOrigin.X-PPaintRect(lParam)^.Rect.Left,
                     URct.Top+ClientOrigin.Y-PPaintRect(lParam)^.Rect.Top,
                     SRCCOPY);
            end
            else UpdateBGround;
          end;
        end
        else UpdateBGround;
      end;
      Result:=0;
    end;
  else
    Result:=DefWindowProc(FWindowHandle,Msg,wParam,lParam);
  end;
end;

function TWebBtn.IsDefined: Boolean;
begin
  if FGlyph.Empty or (HGlyph=0) or (FFrames<1) then Result:=False
  else Result:=True;
end;

procedure TWebBtn.SetStyle(Stl: TWBStyle);
begin
  FMouseOver:=False;
  ResetActivity;
  Deactivate;
  FStyle:=Stl;
end;

procedure TWebBtn.SetPeriod(Prd: Integer);
begin
  if (Prd>0) and (Prd<32000) then FPeriod:=Prd
  else FPeriod:=10;
end;

procedure TWebBtn.SetFrames(j: Integer);
begin
  if j<>FFrames then
  begin
    ResetActivity;
    Resize(UpdateSeries(j));
    FStandByPos:=FFrames-1;
    Deactivate;
  end;
end;

procedure TWebBtn.SetStandByPos(j: Integer);
begin
  if j<1 then FStandByPos:=1 else
  if j<FFrames then FStandByPos:=j else FStandByPos:=FFrames-1;
end;

procedure TWebBtn.SetInverted(Flag: Boolean);
begin
  if Flag<>FInverted then
  begin
    FInverted:=Flag;
    ResetActivity;
    Resize(UpdateSeries(FFrames));
    Deactivate;
    Redraw;
  end;
end;

procedure TWebBtn.SetPaletteMode(PM: TPaletteMode);
begin
  if PM<>FPaletteMode then
  begin
    FPaletteMode:=PM;
    ResetActivity;
    Resize(UpdateSeries(FFrames));
    Deactivate;
    Redraw;
  end;
end;

procedure TWebBtn.SetTransparent(Flag: Boolean);
begin
  ResetActivity;
  FTransparent:=Flag;
  if FTransparent then
  begin
    FMask:=TBitmap.Create;
    FBuffer:=TBitmap.Create;
    FBGround:=TBitmap.Create;
    FTemp:=TBitmap.Create;
  end
  else
  begin
    FTemp.Free;
    FBGround.Free;
    FBuffer.Free;
    FMask.Free;
  end;
  Resize(UpdateSeries(FFrames));
  Deactivate;
  Invalidate;
end;

procedure TWebBtn.SetGlyph(Bmp: TBitmap);
begin
  ResetActivity;
  FGlyph.Assign(Bmp);
  Resize(UpdateSeries(0));
  FStandByPos:=FFrames-1;
  Deactivate;
  Redraw;
end;

procedure TWebBtn.Loaded;
begin
  inherited Loaded;
  if (not FGlyph.Empty) and (HGlyph=0) then
  begin
    Resize(UpdateSeries(FFrames));
    Deactivate;
  end;
  if GetParentForm(self)=nil then raise EWebBtnNoParent.Create(SWebBtnNoParent);
  FParentHandle:=GetParentForm(self).Handle;                                    // Set Handle of the parent window
  UMD_AddMessagePath(FParentHandle,FWindowHandle,WM_DEACTIVATEWB);                  // Create message paths for the control through the parent form
  UMD_AddMessagePath(FParentHandle,FWindowHandle,WM_UPDATEBGROUND);
end;

procedure TWebBtn.Resize(Dim: TPoint);
begin
  Width:=Dim.X;
  Height:=Dim.Y;
  if FTransparent then
  begin
    FMask.Width:=Dim.X;
    FMask.Height:=Dim.Y;
    FMask.Monochrome:=True;
    FBuffer.Width:=Dim.X;
    FBuffer.Height:=Dim.Y;
    FBGround.Width:=Dim.X;
    FBGround.Height:=Dim.Y;
    FTemp.Width:=Dim.X;
    FTemp.Height:=Dim.Y;
    FBGLoaded:=False;
  end;
end;

function TWebBtn.UpdateSeries(j: Integer): TPoint;
var
  Tmp: TBitmap;
  TransColor: Longint;
  IL_Type: Longint;
begin
  if HGlyph<>0 then if ImageList_Destroy(HGlyph) then HGlyph:=0 else raise EWebBtnRR.create(SWebBtnRR);
  if not FGlyph.Empty then
  begin
//  1. Defining size of the frame
    if (j<1) or (j>FGlyph.Width) then
    begin
      Result.Y:=FGlyph.Height;
      if FGlyph.Width<(2*FGlyph.Height) then
      begin
        Result.X:=FGlyph.Width;
        FFrames:=1;
      end
      else
      begin
        Result.X:=FGlyph.Height;
        FFrames:=FGlyph.Width div Result.X;
      end;
    end
    else
    begin
      FFrames:=j;
      Result.Y:=FGlyph.Height;
      Result.X:=FGlyph.Width div j;
    end;
//  2. Initializing the LIST
//  2.1. Difining type of the LIST
    if pmDDB in FPaletteMode then IL_Type:=ILC_COLORDDB
    else if pmBestMapping in FPaletteMode then IL_Type:=ILC_COLOR
    else
      case GetDeviceCaps(Canvas.Handle,BITSPIXEL) of
        4: IL_Type:=ILC_COLOR4;
        8: IL_Type:=ILC_COLOR8;
        16: IL_Type:=ILC_COLOR16;
        24: IL_Type:=ILC_COLOR24;
        32: IL_Type:=ILC_COLOR32;
      else
        IL_Type:=ILC_COLOR;
      end;
    if pmUsePalette in FPaletteMode then IL_Type:=IL_Type or ILC_PALETTE;
    if FTransparent then
    begin
      IL_Type:=IL_Type or ILC_MASK;
      TransColor:=FGlyph.TransparentColor and $00FFFFFF;     // Transparent color
    end;
//  2.3. Creating the imagelist
    HGlyph:=ImageList_Create(Result.X,Result.Y,IL_Type,FFrames,FFrames);
    if HGlyph=0 then raise EWebBtnOSR.Create(SWebBtnOSR);
//  2.2. Loading the frameset to the imagelist
    if not FInverted then
    begin
      Tmp:=TBitmap.Create;
      try
        Tmp.Width:=FGlyph.Width;
        Tmp.Height:=FGlyph.Height;
        BitBlt(Tmp.Canvas.Handle,0,0,Tmp.Width,Tmp.Height,FGlyph.Canvas.Handle,0,0,SRCCOPY);
        if FTransparent then ImageList_AddMasked(HGlyph,Tmp.Handle,TransColor) else ImageList_Add(HGlyph,Tmp.Handle,0);
      finally
        ReleaseDC(0,FGlyph.Canvas.Handle);
        Tmp.Free;
      end;
    end
    else
    begin
      Tmp:=TBitmap.Create;
      try
        Tmp.Width:=Result.X;
        Tmp.Height:=Result.Y;
        for j:=FFrames-1 downto 0 do
        begin
          BitBlt(Tmp.Canvas.Handle,0,0,Result.X,Result.Y,FGlyph.Canvas.Handle,j*Result.X,0,SRCCOPY);
          if FTransparent then ImageList_AddMasked(HGlyph,Tmp.Handle,TransColor) else ImageList_Add(HGlyph,Tmp.Handle,0);
        end;
      finally
        ReleaseDC(0,FGlyph.Canvas.Handle);
        Tmp.Free;
      end;
    end;
  end
  else
  begin
    Result.X:=DefaultWBSize.X;
    Result.Y:=DefaultWBSize.Y;
    FFrames:=0;
  end;
  FState:=wbUndefined;
end;

procedure TWebBtn.DoActivate;
begin
  if Assigned(FOnActivate) then FOnActivate(self);
end;

procedure TWebBtn.DoDeactivate;
begin
  if Assigned(FOnDeactivate) then FOnDeactivate(self);
end;

procedure TWebBtn.DoPrepare;
begin
  if Assigned(FOnPrepare) then FOnPrepare(self);
end;

procedure TWebBtn.DoRestore;
begin
  if Assigned(FOnRestore) then FOnRestore(self);
end;

procedure TWebBtn.DoPlay;
begin
  if Assigned(FOnPlay) then FOnPlay(self);
end;

constructor TWebBtn.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);                                    // Creates inherited structure
  ShowHint:=False;                                             // Show hints
  FStyle:=wbButton;                                            // Sets Default values for the properties
  FState:=wbUndefined;
  FPeriod:=50;
  FTransparent:=True;
  FGlyph:=TBitmap.Create;                                           // Creates all bitmaps
  FMask:=TBitmap.Create;
  FBuffer:=TBitmap.Create;
  FBGround:=TBitmap.Create;
  FTemp:=TBitmap.Create;
  Resize(DefaultWBSize);                                            // Defines format for all bitmaps created
  FWindowHandle:=AllocateHWnd(WindowProc);                          // Creates invisible window for message handling
end;

destructor TWebBtn.Destroy;
begin
  UMD_RemoveMessagePath(FParentHandle,FWindowHandle,WM_DEACTIVATEWB);   // Remove message paths for the control
  UMD_RemoveMessagePath(FParentHandle,FWindowHandle,WM_UPDATEBGROUND);
  ResetActivity;                                                    // Kills all timers
  DeallocateHWnd(FWindowHandle);                                    // Kills the window
  if FTransparent then
  begin
    FTemp.Free;
    FBGround.Free;
    FBuffer.Free;
    FMask.Free;
  end;
  FGlyph.Free;
  if HGlyph<>0 then if ImageList_Destroy(HGlyph) then HGlyph:=0 else raise EWebBtnRR.create(SWebBtnRR);
  inherited Destroy;
end;

{TSoundTrack}

constructor TSoundTrack.Create;
begin
  inherited Create;
  FSrc.Src:=ssFilename;
  FModuleHandle:=GetModuleHandle(PCHAR(Application.ExeName));
end;

function TSoundTrack.Play: Boolean;
begin
  Result:=MME_PlaySoundTrack(FSrc,FModuleHandle);
end;

procedure TSoundTrack.Stop;
type
TEmptySource=record
  Src: TSoundSourceID;        // The source of the sound
  Sync: Boolean;              // Synchro mode
  ID: Pointer;                // Name (ID/Filename)
end;
var
  EmptySrc: TEmptySource;
begin
  EmptySrc.ID:=nil;
  EmptySrc.Src:=ssFilename;
  MME_PlaySoundTrack(TSoundSource(EmptySrc),FModuleHandle);
end;

{TSoundTrack}

constructor TSoundTracks.Create;
begin
  inherited Create;
  FOnActivate:=TSoundTrack.Create;
  FOnDeactivate:=TSoundTrack.Create;
  FOnPrepare:=TSoundTrack.Create;
  FOnRestore:=TSoundTrack.Create;
  FOnPlay:=TSoundTrack.Create;
end;

destructor TSoundTracks.Destroy;
begin
  FOnActivate.Free;
  FOnDeactivate.Free;
  FOnPrepare.Free;
  FOnRestore.Free;
  FOnPlay.Free;
  inherited Destroy;
end;

{TWebBtnEx}

procedure TWebBtnEx.DoActivate;
begin
  inherited DoActivate;
  FSoundTracks.OnActivate.Play;
end;

procedure TWebBtnEx.DoDeactivate;
begin
  inherited DoDeactivate;
  FSoundTracks.OnDeactivate.Play;
end;

procedure TWebBtnEx.DoPrepare;
begin
  inherited DoPrepare;
  FSoundTracks.OnPrepare.Play;
end;

procedure TWebBtnEx.DoRestore;
begin
  inherited DoRestore;
  FSoundTracks.OnRestore.Play;
end;

procedure TWebBtnEx.DoPlay;
begin
  inherited DoPlay;
  FSoundTracks.OnPlay.Play;
end;

constructor TWebBtnEx.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FSoundTracks:=TSoundTracks.Create;
end;

destructor TWebBtnEx.Destroy;
begin
  FSoundTracks.Free;
  inherited Destroy;
end;

{TAniForm}

procedure TAniForm.DoHide;
var
  p11,p12,p21,p22 :TPoint;
begin
  inherited DoHide;
  if FOriginObject<>nil then
  begin
    p11:=self.ClientToScreen(self.ClientRect.topleft);
    p12:=self.ClientToScreen(self.ClientRect.bottomright);
    p21:=FOriginObject.ClientToScreen(FOriginObject.ClientRect.topleft);
    p22:=FOriginObject.ClientToScreen(FOriginObject.ClientRect.bottomright);
    DisplayAnimatedRects(Rect(p11.x,p11.y,p12.x,p12.y),Rect(p21.x,p21.y,p22.x,p22.y));
  end;
end;

procedure TAniForm.DoShow;
var
  p11,p12,p21,p22 :TPoint;
begin
  if FOriginObject<>nil then
  begin
    p11:=self.ClientToScreen(self.ClientRect.topleft);
    p12:=self.ClientToScreen(self.ClientRect.bottomright);
    p21:=FOriginObject.ClientToScreen(FOriginObject.ClientRect.topleft);
    p22:=FOriginObject.ClientToScreen(FOriginObject.ClientRect.bottomright);
    DisplayAnimatedRects(Rect(p21.x,p21.y,p22.x,p22.y),Rect(p11.x,p11.y,p12.x,p12.y));
  end;
  inherited DoShow;
end;

procedure TAniForm.SelectHome(Caller: TControl);
begin
  FOriginObject:=Caller;
end;

procedure TAniForm.DeselectHome;
begin
  FOriginObject:=nil;
end;

procedure TAniForm.ShowFrom(Caller: TControl);
begin
  SelectHome(Caller);
  Show;
end;

procedure TAniForm.ShowModalFrom(Caller: TControl);
begin
  SelectHome(Caller);
  ShowModal;
end;

procedure TAniForm.Paint;
var
  i,j: Integer;
  nx,ny: Integer;
  w,h: Integer;
  sR,sG,sB,eR,eG,eB: Byte;
begin
  inherited Paint;
  case FGradientType of
  gtHor,gtVer:
  begin
    FLastWidth:=Width;
    FLastHeight:=Height;
    Canvas.Pen.Width:=1;
    Canvas.Pen.Mode:=pmCopy;
    Canvas.Pen.Style:=psSolid;
    sR:=FStartColor and $000000FF;
    eR:=FEndColor and $000000FF;
    sG:=(FStartColor and $0000FF00) shr 8;
    eG:=(FEndColor and $0000FF00) shr 8;
    sB:=(FStartColor and $00FF0000) shr 16;
    eB:=(FEndColor and $00FF0000) shr 16;
    if FGradientType=gtVer then w:=Height else w:=Width;
    for j:=0 to w do
    begin
      Canvas.Pen.Color:=$00010000*((sB*(w-j)+eB*j)div w)+
                        $00000100*((sG*(w-j)+eG*j)div w)+
                                  ((sR*(w-j)+eR*j)div w);
      if FGradientType=gtVer then
      begin
        Canvas.MoveTo(0,j);
        Canvas.LineTo(Width,j);
      end
      else
      begin
        Canvas.MoveTo(j,0);
        Canvas.LineTo(j,Height);
      end;
    end;
  end;
  else
    if FBGround<>nil then
    if (not FBGround.Empty) and (FBGround.Width>0) and (FBGround.Height>0) then
    begin
      w:=FBGround.Width;
      h:=FBGround.Height;
      nx:=Width div w;
      ny:=Height div h;
      for j:=0 to ny do
      for i:=0 to nx do
      BitBlt(Canvas.Handle,i*w,j*h,w,h,FBGround.Canvas.Handle,0,0,SRCCOPY);
    end;
  end;
end;

procedure TAniForm.SetBGround(Bmp: TBitmap);
begin
  if FBGround<>nil then
  begin
    FBGround.Free;
    FBGround:=nil;
  end;
  if Bmp<>nil then
  if (not Bmp.Empty) and (Bmp.Width>0) and (Bmp.Height>0) then
  begin
    FBGround:=TBitmap.Create;
    FBGround.Assign(Bmp);
  end;
  Invalidate;
end;

procedure TAniForm.Resize;
begin
  inherited Resize;
  case FGradientType of
    gtVer: if FLastHeight<>Height then Invalidate;
    gtHor: if FLastWidth<>Width then Invalidate;
  end;
end;

procedure TAniForm.HGradient(SC,EC: TColor);
begin
  if (SC=clNone) or (EC=clNone) then FGradientType:=gtDisabled
  else
  begin
    FStartColor:=SC;
    FEndColor:=EC;
    FGradientType:=gtHor;
    if FBGround<>nil then
    begin
      FBGround.Free;
      FBGround:=nil;
    end;
  end;
  Invalidate;
end;

procedure TAniForm.VGradient(SC,EC: TColor);
begin
  if (SC=clNone) or (EC=clNone) then FGradientType:=gtDisabled
  else
  begin
    FStartColor:=SC;
    FEndColor:=EC;
    FGradientType:=gtVer;
    if FBGround<>nil then
    begin
      FBGround.Free;
      FBGround:=nil;
    end;
  end;
  Invalidate;
end;

constructor TAniForm.Create(AOwner: TComponent);
begin
  FGradientType:=gtDisabled;
  inherited Create(AOwner);
end;

destructor TAniForm.Destroy;
begin
  if FBGround<>nil then
  begin
    FBGround.Free;
    FBGround:=nil;
  end;
  inherited Destroy;
end;

{Other functions}

procedure Register;
begin
  RegisterComponents('Trifles',[TWebBtn,TWebBtnEx]);
end;

end.
